
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>简单调试器的实现(三)完善调试器 / 憋错料</title>

    <meta name="description" content="简单调试器的实现(三)完善调试器 Dll加载: case LOAD_DLL_DEBUG_EVENT: // Read the debugging information included in the newly // loaded DLL. Be sure to close the handle to the loaded DLL // with CloseHandle. //Dll加载时会进行这个事件 dwContinueStatus = OnLoadDllDebugEvent(DebugEvent); break; DWO">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">简单调试器的实现(三)完善调试器</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><strong>Dll加载：</strong></p>
<p>case LOAD_DLL_DEBUG_EVENT:<br />			// Read the debugging information included in the newly <br />			// loaded DLL. Be sure to close the handle to the loaded DLL <br />			// with CloseHandle.</p>
<p>//Dll加载时会进行这个事件</p>
<p>dwContinueStatus = OnLoadDllDebugEvent(DebugEvent);<br />			break;</p>
<p>DWORD OnLoadDllDebugEvent(const LPDEBUG_EVENT DebugEvent)<br />{<br />//我们可以通过DebugEvent-&gt;u.LoadDll.hFile获得Dll的句柄</p>
<p>//但是，没有直接从HANDLE-&gt;Path的API，需要代码进行转化</p>
<p>//具体方法很容易查找到，这里就不介绍了。</p>
<p>　　GetFileNameFromHandle(DebugEvent-&gt;u.LoadDll.hFile);</p>
<p>　　return DBG_CONTINUE;<br />}</p>
<p><strong>读取内存：</strong></p>
<p>读取内存的API我们已经介绍过了ReadProcessMemory。</p>
<p>部分代码：</p>
<p>//Addr &nbsp;读取的地址</p>
<p>//Size = sizeof(BYTE)</p>
<p>void *lpBuff;</p>
<p>lpBuff = malloc(Size);</p>
<p>SIZE_T bytesRead;</p>
<p>for (i = 0; i &lt; 32; i++)<br />	{<br />		　　if ((i % 8) == 0)　　　　　　//输出4行 8列<br />			　　　　printf("\n%x    ", Addr);<br />		　　if (FALSE == ReadProcessMemory(G_Process, Addr, lpBuff, Size, &amp;bytesRead))<br />		　　{<br />			　　　　printf("??   ");　　　　　　//读取失败就输出" ？？"<br />		　　}<br />		　　else<br />		　　{<br />			　　　　printf("%.2x ", *(BYTE*)lpBuff);<br />		　　}<br />		　　Addr = Addr + Size;<br />	}</p>
<p>free(lpBuff);</p>
<p><strong>&nbsp;效果：</strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nMjAxNS83MzYzNzYvMjAxNTAzLzI4MTg1NTEyODgwNzk3My5qcGc=.jpg" /></strong></p>
<p><strong>这章就讲这么多了。。。下一章节将详细的讲解软断点。</strong></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 03:36:50 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>简单调试器的实现(三)完善调试器的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyDPje4.html" rel="bookmark">LoadRunner&plus;Android模所器实现抓包并调试本地服务端</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				步骤就是 1:新建LR脚本.协议选择Mobile Application - HTTP/HTML 2:在record里选择第三个:Record Emulator........ 3:  选择下一步后,在emulator to record选择模拟器tools目录下的emulator.exe                     command line 里输入avd虚拟机的名称:用@连接  如@test      working directory 随便选个路径就行了 4:然后运行,就会自动启			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4AmA6v4.html" rel="bookmark">监听按钮点击事件的三种方式实现及调试信息输出的三种方式实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				监听按钮点击事件的三种方式实现: 1.匿名内部类 2.外部独立类 3.接口实现 package com.example.button; import android.support.v7.app.ActionBarActivity; import android.os.Bundle; import android.util.Log; import android.view.Menu; import android.view.MenuItem; import android.view.View;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JgDxPM.html" rel="bookmark">&lpar;简单&rpar;华为荣耀4A SCL-TL00的usb调试模式在哪里打开的方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				当我们使用Pc通过数据线连接上安卓手机的时候,如果手机没有开启USB开发者调试模式,Pc则没法成功检测到我们的手机,在一些情况下,我们使用的一些功能较好的应用软件比如之前我们使用的一个应用软件引号精灵,老版本就需要开启USB开发者调试模式下使用,现当新版本不需要了,这时候我们需要找解决方法将手机的USB开发者调试模式开启,这里我们介绍华为荣耀4A SCL-TL00如何开启USB开发者调试模式的步骤. 首先,在华为荣耀4A SCL-TL00应用程序界面点击设置ICON,进入华为荣耀4A SCL-T			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3O1Z2KM.html" rel="bookmark">&lpar;简单&rpar;华为荣耀5X KIW-AL10的usb调试模式在哪里开启的方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				经常我们使用电脑连接安卓手机的时候,如果手机没有开启USB开发者调试模式,电脑则没能够成功读到我们的手机,有时我们使用的一些功能较强的工具如以前我们使用的一个工具引号精灵,老版本就需要打开USB开发者调试模式下使用,现经常新版本不需要了,如果遇到此情况我们需要想办法将手机的USB开发者调试模式打开,这里我们介绍华为荣耀5X KIW-AL10如何开启USB开发者调试模式的步骤.第一步,在华为荣耀5X KIW-AL10应用程序界面打开设置icon,进入华为荣耀5X KIW-AL10系统设置界面.第二			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/949vynM.html" rel="bookmark">js调试系列&colon; 源码定位与调试&lbrack;基础篇&rsqb;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				js调试系列目录: - 如果看了1, 2两篇,你对控制台应该有一个初步了解了,今天我们来个简单的调试.昨天留的三个课后练习,差不多就是今天要讲的内容.我们先来处理第一个问题:1. 查看文章下方 推荐 这个功能所调用的函数源码其实非常简单,点放大镜选中那个推荐即可.这个  votePost(cb_entryId,'Digg')  就是推荐按钮所调用的函数了,是不是非常简单. 第二个问题,定位到函数所在文件位置.其实也是非常简单的,当然,不熟悉控制台的朋友也许不知道怎么看.我在控制台输入 voteP			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kGkDl0.html" rel="bookmark">ssh 配置文件讲解大全  ssh调试模式  sftp scp strace进行调试</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ssh 配置文件讲解大全  ssh调试模式  sftp scp strace进行调试 http://blog.chinaunix.net/uid-16728139-id-3265394.html 最近在研究openssh的源代码,不得不折服它代码的精炼和彪悍,即便搞清楚了其架构和思路之后,愣是到头来愣是发现,其实这个小东西还是有很多不为人知却又是研究代码不得不了解的知识,偶然发现如此强悍的介绍, 利索当然地笑纳一下. 一)客户端与服务端的通讯认证流程: 第一阶段: 双方协商SSH版本号和协议,协			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0nRGAp0.html" rel="bookmark">js调试系列：断点和动态调试&lbrack;基础篇&rsqb;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				js调试系列: 断点与动态调试[基础篇] js调试系列目录: - js调试系列: 初识控制台 js调试系列: 控制台命令行API js调试系列: 源码定位与调试[基础篇] js调试系列: 断点与动态调试[基础篇] js调试系列: 调试基础与技巧 额,我说的不是张敬轩的 断点 这首歌,是调试用到的断点,进入正题吧. 昨天留的课后练习 1. 分析 votePost 函数是如何实现 推荐 的.其实我们已经看到了源码,只要读下源码即可知道他是怎么实现的了. 文本 function votePost(n,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49b2YXM.html" rel="bookmark">【OPENGL】第三章 着色器基础（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在这一章,我们会学习什么是着色器(Shader),什么是着色器语言(OpenGL Shading Language-GLSL),以及着色器怎么和OpenGL程序交互. 首先我们先来看看什么叫着色器. Shader(着色器)是用来实现图像渲染的,用来替代固定渲染管线的可编程程序. 着色器替代了传统的固定渲染管线,可以实现3D图形学计算中的相关计算,由于其可编程性,可以实现各种各样的图像效果而不用受显卡的固定渲染管线限制.这极大的提高了图像的画质. 在上一篇文章( http://www.cnblog			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41zGZoM.html" rel="bookmark">【Java】使用Eclipse进行远程调试，Windows下开启远程调试</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原博链接:http://blog.csdn.net/sunyujia/article/details/2614614 今天决定做件有意义的事,写篇图文并茂的blog,为什么要图文并茂?因为很多事可能用语言也说不明白,从以前我发表的一篇文章可以看得出来,http://blog.csdn.net/sunyujia/archive/2008/03/23/2211109.aspx 我的朋友们普通反应看完后觉得不知所云,可能是我写的太简单,下面步入正题. 什么是远程调试,就是在A机器上利用Eclipse单			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/kMLbNQ3.html" rel="bookmark" class="title">Hive 10、Hive的UDF、UDAF、UDTF</a>
					<div>
						Hive自定义函数包括三种UDF.UDAF.UDTF UDF(User-Defined-Function) 一进一出 UDAF(User- Defined Aggregation Funcation) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pvVPJ0.html" rel="bookmark" class="title">仿校内textarea输入框字数限制效果</a>
					<div>
						这是一个仿校内textarea回复消息输入框限制字数的效果,具体表现如下: 普通状态是一个输入框,当光标获取焦点时,出现字数记录和回复按钮 PS:上边那个小三角可不是用的图片. 普通状态效果如下: 获 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47p5Z6M.html" rel="bookmark" class="title">天然工坊模式分销系统技术开发</a>
					<div>
						天然工坊模式分销系统技术开发(何 188.264.66052 微/电)天然工坊模式开发.天然工坊系统开发.天然工坊模式系统技术开发等. 2016年1月27日,移动互联电商平台&quot;天然工坊&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pe5bwM.html" rel="bookmark" class="title">ArcGIS软件操作&mdash;&mdash;地图制图</a>
					<div>
						ArcGIS软件操作系列二(地图制图) 2016年毕业,参加工作,除了平时出差,大部分时间都在使用ArcGIS处理数据.制图,在此,先将一些制图的小心得撰写出来,希望能与各位共同交流. 1 数据准备: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kXm8l3.html" rel="bookmark" class="title">hbase异常&colon;java&period;io&period;IOException&colon; Unable to determine ZooKeeper ensemble</a>
					<div>
						项目中用到hbase,有时候可能会报一些异常,比如java.io.IOException: Unable to determine ZooKeeper ensemble 等等,当出现这个问题时,某某说 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4A65LyM.html" rel="bookmark" class="title">matlab公共函数之保存YUV数据</a>
					<div>
						matlab保存图像为YUV格式的脚本函数 % function flag = saveYUVData(filename,Y,U,V,format) % input params. % filenam ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KB9yYM.html" rel="bookmark" class="title">Xml解析之排除注释</a>
					<div>
						总结: 1.Xml中的注释也被当作节点元素: 示例XMLFile1.xml: &lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot; ? ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mmo7K13.html" rel="bookmark" class="title">【读书笔记】iOS网络-测试与操纵网络流量</a>
					<div>
						一,观测网络流量. 观测网络流量的行为叫做嗅探或数据包分析. 1,嗅探硬件. 从iOS模拟器捕获数据包不需要做特别的硬件或网络配置.如果需要捕获这些数据包,那么可以使用嗅探软件来监听回送设备或是用于连 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLZjZA3.html" rel="bookmark" class="title">微信的高级群发接口</a>
					<div>
						微信新开放的群发接口,可以说是很多商家梦寐以求的福音.基本很多商家都曾梦想过,把自己的信息直接推送到客户手机上.但经过这两天的研究,微信的群发接口并没有开放到商家理想的程度,究其原因可能是怕带来更坏的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xZJp74.html" rel="bookmark" class="title">python ABC</a>
					<div>
						因为项目需要,总是会有各种各样要重命名文件的场合,manual的方法当然不可取,bat的方法又感觉不够强大,所以就从零开始学python,就为了能够自动批量修改文件名,倒腾了一个周六,总算可以了 :) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AE82z4.html" rel="bookmark" class="title">MySQLdb库连接MySQL数据库</a>
					<div>
						Cacti是一套基于PHP,MySQL,SNMP及RRDTool开发的网络流量监测图形分析工具.Cacti是通过 snmpget来获取数据,使用 RRDtool绘画图形,而且你完全可以不需要了解RRD ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41wEoY0.html" rel="bookmark" class="title">Linux内核分析（第八周）</a>
					<div>
						进程的切换和系统的一般执行过程 一.进程切换的关键代码switch_to分析 1.进程调度与其时机分析 分类: 第一种分类 I/O-bound:频繁的进行I/O:会花很多时间等待I/O操作完成 CPU ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OyBEgM.html" rel="bookmark" class="title">Selenium 学习笔记---Selenium basic all in one</a>
					<div>
						Selenium 是这些年非常流行的Web UI 自动化测试工具, 很多同学学习并使用过Selenium.但是一些问题仔细想来是不是让你觉得有些困惑,比如说Selenium 到底是什么东西,为什么能支 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3v1l2L0.html" rel="bookmark" class="title">HDU 2227 Find the nondecreasing subsequences  dp思想 &plus; 树状数组</a>
					<div>
						http://acm.hdu.edu.cn/showproblem.php?pid=2227 用dp[i]表示以第i个数为结尾的nondecreasing串有多少个. 那么对于每个a[i] 要去找 & ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZG1ZJ4.html" rel="bookmark" class="title">带进度条的上传（Asp&period;net&plus;MVC&plus;Uploadify）</a>
					<div>
						1.Uploadify简介 Uploadify是基于jQuery的一种上传插件,支持多文件.带进度条显示上传,在项目开发中常被使用. Uploadify官方网址:http://www.uploadif ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mznv2lM.html" rel="bookmark" class="title">高频词统计器</a>
					<div>
						目录: 1.程序 1.程序 2.nonesense words #word遍历行,word处理,去除各种标点,怪异符号,最后计算word出现个数#判断单词是否是在停用词列表 def none_sens ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MorEqB4.html" rel="bookmark" class="title">&lbrack;转载&rsqb;发邮件组件Nodemailer&mdash;&mdash;nodejs中间件系列</a>
					<div>
						从零开始nodejs系列文章,将介绍如何利Javascript做为服务端脚本,通过Nodejs框架web开发.Nodejs框架是基于V8的引擎,是目前速度最快的Javascript引擎.chrome浏 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kgkBL0.html" rel="bookmark" class="title">oracle数据库基本理解</a>
					<div>
						一.概念 1. 数据库 (Database) 什么是数据库? 数据库是依照某种数据模型组织起来并存放二级存储器中的数据集合. 这种数据集合具有如下特点: 尽可能不重复,以最优方式为某个特定组织的多种应 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4ApVwz3.html" rel="bookmark" class="title">java代码乱序问题</a>
					<div>
						java两个线程互相访问的时候并不能按照你的思路运行,因为执行语句可能有前后快慢之分,比如a=1和flag=true.下面线程B访问的时候 这两个赋值语句不一定按顺序执行 产生这种原因是因为指令重排序 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mgn7oB4.html" rel="bookmark" class="title">Android中使用IntentService执行后台任务</a>
					<div>
						IntentService提供了一种在后台线程中执行任务的方式,适合处理执行时间较长的后台任务. 优点: (1)IntentService运行在单独的线程中,不会阻塞UI线程 (2)IntentSer ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
